#include "ftfconfigplot.h"
#include <QTWatcher>
#include <qwt_plot_curve.h>
#include <QtDebug>

FtfConfigPlot::FtfConfigPlot(QWidget *parent) : TPlotLightMarker(parent)
{
    setTimeScaleDrawEnabled(false);
    setTitleOnCanvasEnabled(true);
    m_type = Bpm;
}

QString FtfConfigPlot::markerText(const QwtPlotCurve *relatedCurve, const int index)
{
    QString txt = relatedCurve->title().text() + "\n";
    qDebug() << "m_names" << m_names;
    if(index < m_names.size())
    {
        txt += m_names.at(index) + "\n";
        if(m_type == Bpm)
            txt += QString("Position: %1mm").arg(relatedCurve->y(index));
        else
            txt += QString("Current: %1A").arg(relatedCurve->y(index));
    }
    return txt;
}

void FtfConfigPlot::setNamesSource(const QString& src)
{
    QTWatcher *namesWatcher = new QTWatcher(this);
    namesWatcher->attach(&m_names);
    namesWatcher->setSource(src, POLLED_REFRESH, 60000);
}
