#ifndef OPTSENSORSOptSensorsWeightManager_H
#define OPTSENSORSOptSensorsWeightManager_H

class QWidget;
class TangoConfigurationParameters;
class ELed;

#include <QList>
#include <QVariant>
#include <tvariant.h>
#include <QWidget>

class OptSensorsWeightManager : public QWidget
{
    Q_OBJECT
public:

    enum Columns { BpmLabels, Bpm, LedStReadback, LedOptimizationControlled };

    OptSensorsWeightManager(QWidget *containerWidget);

public slots:
    void setupBpms(const QStringList& labels, const QString& attrName);

    void setAllToValue();

private slots:
    void manageSelection(const QString&);

    void apply();

    void configurationReady(const TangoConfigurationParameters *cp);

    void refreshLeds(const TVariant &v);

    void initWriter(const TVariant &v);

private:
    QWidget *m_containerWidget, *m_tabWidget;
    QList<QVariant> m_currentSetPointVector;
    int m_currentSelectedIndex;
};

#endif // OptSensorsWeightManager_H
