/***************************************************************************
 *   Copyright (C) 2010 by Giacomo Strangolino,T2 PT 025,,   *
 *   giacomo.strangolino@elettra.trieste.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "rcombobox.h"

RComboBox::RComboBox(QWidget *parent ) : TComboBox(parent), QTangoComProxyReader(this)
{
	connect(QTangoComProxyReader::qtangoComHandle(), SIGNAL(newData(const TVariant&)),
		this, SLOT(refresh(const TVariant&)));
}


RComboBox::~RComboBox()
{
	
}

void RComboBox::refresh(const TVariant& v)
{
	if(v.quality() == ATTR_VALID && v.canConvertToStringVector())
	{
		if(!isEnabled())
			setEnabled(true);
		QVector<QString> items = v.toStringVector();
		/* save currentText */
		QString curText = currentText();
		clear();
		QStringList newItems = items.toList();
		insertItems(0, newItems);
		for(int i = 0; i < count(); i++)
		{
			if(itemText(i) == curText)
			{
				setCurrentIndex(findText(curText));
				break;
			}
		}
		setToolTip(QString("Current selection:\n%1"
				"\n\n%2").arg(currentText()).arg(v.message()));
	}
	else
	{
		setDisabled(true);
		setToolTip(QString("Attribute invalid or data conversion error:\n%1").arg(v.message()));
	}
}
