/***************************************************************************
 *   Copyright (C) 2010 by Giacomo Strangolino,T2 PT 025,,   *
 *   giacomo.strangolino@elettra.trieste.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef RCOMBOBOX_H
#define RCOMBOBOX_H

#include <TComboBox>
#include <com_proxy_reader.h>

/**
A TComboBox that refreshes its elements being a QTangoComProxyReader.

	@author Giacomo Strangolino,T2 PT 025,, <giacomo.strangolino@elettra.trieste.it>
*/
class RComboBox : public TComboBox, public QTangoComProxyReader
{
	Q_OBJECT
public:
    RComboBox(QWidget* parent);
    
    /* must reimplement the following 4 methods to provide unique access for ProxyInterface
     * methods.
     */
    QString tangoPoint() const { return QTangoComProxyReader::source(); }
    bool isReader() const { return true; }
    bool isWriter() const { return true; }
    QTangoCommunicationHandle* qtangoComHandle() const { return QTangoComProxyWriter::qtangoComHandle(); };
    
    void setSource(const QString& src) { QTangoComProxyReader::setSource(src); }
    
protected:
	void refresh(const TVariant& v);

    ~RComboBox();

};

#endif
