#include "weightlabel.h"
#include <QMouseEvent>
#include <QPaintEvent>
#include <QPainter>
#include <elettracolors.h>
#include <QtDebug>

WeightLabel::WeightLabel(QWidget *parent, const QString& label, int index)
    : TLabel(parent)
{
    m_isSelected = false;
    m_label = label;
    m_index = index;
}

void WeightLabel::mousePressEvent(QMouseEvent *mouseEvent)
{
    TLabel::mousePressEvent(mouseEvent);
    if(mouseEvent->button() == Qt::LeftButton)
        emit clicked(objectName());
}

void WeightLabel::setSelected(bool selected)
{
    m_isSelected = selected;
    update();
}

void WeightLabel::paintEvent(QPaintEvent *pe)
{
    TLabel::paintEvent(pe);
    if(m_isSelected)
    {
        QPainter p(this);
        QPen pen;
        pen.setWidth(6.0);
        pen.setColor(KBLUE);
        p.setPen(pen);
        p.drawRoundedRect(pe->rect(), 1.0, 1.0);
    }
}

