#ifndef WEIGHTLABEL_H
#define WEIGHTLABEL_H

#include <TLabel>
#include <SpectrumWriter>

class WeightLabel : public TLabel
{
    Q_OBJECT
public:
    WeightLabel(QWidget *parent, const QString& label, int index);

    bool isSelected() const { return m_isSelected; }

    QString label() const { return m_label; }

    int index() const { return m_index; }

public slots:
    void setSelected(bool selected);

signals:
    void clicked(const QString& label);

protected:
    void mousePressEvent(QMouseEvent *);

    void paintEvent(QPaintEvent *);

private:
    bool m_isSelected;
    QString m_label;
    unsigned m_index;
};

#endif // WEIGHTLABEL_H
