#ifndef WEIGHTMANAGER_H
#define WEIGHTMANAGER_H

class QWidget;
class TangoConfigurationParameters;
#include <QList>
#include <QVariant>
#include <tvariant.h>
#include <QWidget>

class WeightManager : public QWidget
{
    Q_OBJECT
public:

    enum Columns { BpmLabels, HBpm, VBpm, CorrLabels,
                   HCorr, VCorr, EigLabels, HEig, VEig };

    WeightManager(QWidget *containerWidget);

public slots:
    void setupBpms(const QStringList& labels, const QString& horBpmAttr, const QString& verBpmAttr);

    void setupCorrAndEig(const QStringList &labels,
                         const QString& horCorrAttr, const QString& verCorrAttr,
                         const QString& horEigAttr, const QString& verEigAttr);

private slots:
    void manageSelection(const QString&);

    void apply();

    void configurationReady(const TangoConfigurationParameters *cp);

    void initWriter(const TVariant &v);

private:
    QWidget *m_containerWidget, *m_tabWidget;
    QList<QVariant> m_currentSetPointVector;
    int m_currentSelectedIndex;
};

#endif // WEIGHTMANAGER_H
